-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
HolidaySystem = {}
HolidaySystem.Functions = {}
HolidaySystem.Holidays = {}
----------------------------------------------------------------------
--								FUNCTIONS
----------------------------------------------------------------------
----------------------------------------------------------------------
-- void CreateGifts(object user,string holiday)
-- give the player the gifts for the given holiday object.
----------------------------------------------------------------------
HolidaySystem.Functions.CreateGifts = function(user,holiday)
	local backpackUser = user:GetEquippedObject("Backpack")
	if(backpackUser ~= nil) then
		local bag = CreateObjInContainer(HolidaySystem.Holidays[holiday].Container.Template,backpackUser,GetRandomDropPosition(backpackUser),"CreateGiftContainer")
		RegisterSingleEventHandler(EventType.CreatedObject,"CreateGiftContainer",function(success,obj)
			if(success) then
				obj:SetColor(HolidaySystem.Holidays[holiday].Container.Color)
				obj:SetName(HolidaySystem.Holidays[holiday].Container.Name)
			end
		end)
		if(bag ~= nil) then
			if(HolidaySystem.Holidays[holiday].Rewards ~= nil) then
				for k,v in pairs(HolidaySystem.Holidays[holiday].Rewards) do
					HolidaySystem.Functions.HandleReward(v)
				end
			end
		end
	end
end
----------------------------------------------------------------------
-- bool HandleReward(HolidaySystem.Holiday.HolidayObject.Rewards rewardentry)
-- if the holiday is active return true other wise return false
----------------------------------------------------------------------
HolidaySystem.Functions.HandleReward = function(rewardentry)
	print("Reward Entry Type:"..rewardentry.Type)
	--todo reward entry generation
end
----------------------------------------------------------------------
-- bool IsHoliday(object user,string holiday)
-- if the holiday is active return true other wise return false
----------------------------------------------------------------------
HolidaySystem.Functions.IsHoliday = function(user,holiday)
	local time = os.time()
	if(time >= HolidaySystem.Holidays[holiday].EventTimeStart and time <= HolidaySystem.Holidays[holiday].EventTimeEnd) then return true end
	return false 
end
----------------------------------------------------------------------
-- void CheckHolidays(object user)
-- check each Holiday object to see if its active
-- check to see if the player has already recieved the gift(s)
-- reward player if all checks show they can get the gifts.
----------------------------------------------------------------------
HolidaySystem.Functions.CheckHolidays = function (user)
	local CanGiveReward = false
	local HolidayCollectedByPlayer = user:GetObjVar("HolidaySystem.Collected")
	if(HolidayCollectedByPlayer == nil) then
		HolidayCollectedByPlayer = {}
		user:SetObjVar("HolidaySystem.Collected",HolidayCollectedByPlayer)
	end
	--NEED TO CORRECT HOLIDAYSYSTEM.COLLECTED LOGIC
	for k,v in pairs(HolidaySystem.Holidays) do
		print(k,v)
		if(HolidaySystem.Functions.IsHoliday(user,k)) then
			CanGiveReward = true
			if(HolidayCollectedByPlayer[k] ~= nil) then
				CanGiveReward = false
				user:SystemMessage("you already have collected this seasons award.")
				return
			end
			if(CanGiveReward) then
				HolidaySystem.Functions.CreateGifts(user,k)
				table.insert(HolidayCollectedByPlayer,k)
				user:SetObjVar("HolidaySystem.Collected",HolidayCollectedByPlayer)
				user:SystemMessage("[FF7700]"..HolidaySystem.Holidays[k].HolidayRewardGreeting)
			end
		end
	end
end
-----------------------------------------------------------------------------
--								  HOLIDAY DATA
-----------------------------------------------------------------------------
HolidaySystem.Holidays.Halloween2018 = 
{
	HolidayName="Halloween 2018",
	HolidayRewardGreeting="Welcome to our 2018 Halloween Holiday Season. Enjoy your gift(s) and thank you for playing our server. Happy Holidays!",
	EventTimeStart = os.time{year=2018,month=8,day=31,hour=0,min=0,sec=0},
	EventTimeEnd = os.time{year=2018,month=10,day=31,hour=23,min=59,sec=59},
	Container=
	{
		Name 		="[FF7700]Hallowed Pouch[-]",		-- *Container Name Override
		Template	="pouch",							-- *Container Template Name
		Color 		="FF7700",							-- *New Color For Container
	},
	Rewards=
	{													-- * means you have to have in entry
		{												-- ? means this not required to spawn the item, but modifies the item if needed.
			Type 		= "Item",						-- *Switch Type to Filter Rewards
			Template 	= "weapon_dagger",				-- *Template for Item Type Rewards 
			Hue 		= 42,							-- ?New Hue for Item(not required)
			Color 		= "FF7700",						-- ?New Color for Item(not required)
			Name 		= "[FF7700]Hollowed Dagger[-]",	-- ?Item Name Override(not required)
			Chance 		= 0.75, 						-- ?Chance To Appear in Bag(not required)
			MinAmount 	= 1,							-- ?Minimum Amount of Stacksize if stackable
			MaxAmount   = 1,                            -- ?Maximum Amount of Stacksize if stackable
		},
	},
}
