-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
function LoadProjectPhoenixUI()
	ShowProjectPhoenixAdminWindow()
	--ShowLeftPane()
end

function ShowProjectPhoenixAdminWindow()
	dynWindow = nil
	local dynWindow = DynamicWindow("ProjectPhoenixAdminWindow","Project Phoenix Admin",480,50,-200,-200,"TransparentDraggable","Bottom")
	dynWindow:AddImage(100,-25,"Blank",300,25,"Sliced","252525")
	dynWindow:AddImage(100,-25,"SectionDividerFrames_nobackground",300,25,"Sliced","FFFF00")
	dynWindow:AddLabel(113,-20,"[FFFF00]Project Phoenix Administrator Menu",300,25,22,"left")
	dynWindow:AddImage(0,0,"Blank",500,70,"Sliced","151515")
	dynWindow:AddImage(0,0,"SectionDividerFrames_nobackground",500,70,"Sliced","FFFF00")
	dynWindow:AddUserAction(10,10,
		{
			ID="CreateSpawner",
			ActionType="CreateSpawner",
			DisplayName="Create Spawner",
			Tooltip="This will create a spawner at the targeted location",
			Icon="Magic Barrier",
			ServerCommand="CreateSpawner",
			Enabled=true
		})
	dynWindow:AddUserAction(55,10,
		{
			ID="CreateRegion",
			ActionType="CreateRegion",
			DisplayName="Create Region",
			Tooltip="This will create a region at the targeted location.",
			Icon="Night",
			ServerCommand="CreateRegion",
			Enabled=true
		})
	dynWindow:AddUserAction(100,10,
		{
			ID="CreateMerchantMale",
			ActionType="CreateMerchantMale",
			DisplayName="Create Male Merchant",
			Tooltip="This will create a new male merchant at the targeted location.",
			Icon="Fire Mastery",
			ServerCommand="CreateMerchantMale",
			Enabled=true
		})
	dynWindow:AddUserAction(145,10,
		{
			ID="CreateMerchantFemale",
			ActionType="CreateMerchantFemale",
			DisplayName="Create Female Merchant",
			Tooltip="This will create a new female merchant at the targeted location.",
			Icon="Unholy Mastery",
			ServerCommand="CreateMerchantFemale",
			Enabled=true
		})
	dynWindow:AddUserAction(190,10,
		{
			ID="DeleteItemWithTarget",
			ActionType="DeleteItemWithTarget",
			DisplayName="Destroy Target",
			Tooltip="This will destroy any non permanent object in the game.",
			Icon="pillaroffire",
			ServerCommand="destroy",
			Enabled=true
		})
	dynWindow:AddUserAction(235,10,
		{
			ID="GetItemInfo",
			ActionType="GetItemInfo",
			DisplayName="Object Information",
			Tooltip="This will display an information window on the targeted object.",
			Icon="evaluate",
			ServerCommand="info",
			Enabled=true
		})
	dynWindow:AddUserAction(280,10,
		{
			ID="ToggleItemPermanent",
			ActionType="ToggleItemPermanent",
			DisplayName="Toggle Object Permanency",
			Tooltip="This will toggle an objects permanency value in the world.",
			Icon="Ice Barrier",
			ServerCommand="permanent",
			Enabled=true
		})
	dynWindow:AddUserAction(325,10,
		{
			ID="MoveObjectToLocation",
			ActionType="MoveObjectToLocation",
			DisplayName="Move Object",
			Tooltip="This will move targeted object and move it to the targeted location.",
			Icon="attack_target",
			ServerCommand="MoveObjectToLocation",
			Enabled=true
		})
	dynWindow:AddUserAction(370,10,
		{
			ID="CreateDungeonController",
			ActionType="CreateDungeonController",
			DisplayName="Create Dungeon Controller",
			Tooltip="This will create a dungeon_controller at the targeted location.",
			Icon="Bash",
			ServerCommand="CreateDungeonController",
			Enabled=true
		})					
	this:OpenDynamicWindow(dynWindow)
end
local leftPaneMinimized = false
function ShowLeftPane(searchstring,minimized)
	dynWindow = nil
	local winWidth = 300
	local winHeight = 600
	if(minimized) then
		winWidth = 200
		winHeight = 25
	end

	local dynWindow = DynamicWindow("LeftPaneAdminWindow","Project Phoenix Admin",winWidth,winHeight,-100,-100,"TransparentDraggable","Left")
	dynWindow:AddImage(50,-25,"Blank",200,25,"Sliced","252525")
	dynWindow:AddImage(50,-25,"SectionDividerFrames_nobackground",200,25,"Sliced","FFFF00")
	dynWindow:AddLabel(90,-20,"[FFFF00]Decorate World",140,25,22,"left")

	dynWindow:AddImage(0,0,"Blank",winWidth,winHeight,"Sliced","151515")
	dynWindow:AddImage(0,0,"SectionDividerFrames_nobackground",winWidth,winHeight,"Sliced","FFFF00")
	if not(minimized) then
		dynWindow:AddTextField(10,10,220,20, "search_query", "")
		dynWindow:AddButton(235,8,"Search:na","Search",55,18,"enter a search value and click search",nil,false,"")

		local scrollWindow = ScrollWindow(10,40,275,540,20)
		if(searchstring == nil) then
			for k,v in pairs(CLIENTIDREFERENCE) do
				local scrollElement = ScrollElement()
				scrollElement:AddLabel(5,5,v.Name,200,18,18,"left")
				scrollElement:AddButton(205,5,"Create:"..v.Name,"Create",50,18,"enter descript here",nil,false,"")
				scrollWindow:Add(scrollElement)
			end
		else
			local searchlist = {}
			for k,v in pairs(CLIENTIDREFERENCE) do
				if(string.match(v.Name, searchstring)) then
					table.insert(searchlist,v)
				end
			end		
			for k,v in pairs(searchlist) do
				local scrollElement = ScrollElement()
				scrollElement:AddLabel(5,5,v.Name,200,18,18,"left")
				scrollElement:AddButton(205,5,"Create:"..v.Name,"Create",50,18,"enter descript here",nil,false,"")
				scrollWindow:Add(scrollElement)
			end		
		end
		dynWindow:AddScrollWindow(scrollWindow)
		this:SystemMessage("ClientID Reference Reloaded...")
	end
	this:OpenDynamicWindow(dynWindow)
end

RegisterEventHandler(EventType.DynamicWindowResponse,"ProjectPhoenixAdminWindow",
	function (user,buttonId,fieldData)
		if(buttonId == "Args") then

		end
	end)

local tableData = nil

RegisterEventHandler(EventType.DynamicWindowResponse,"LeftPaneAdminWindow",
	function (user,buttonId,fieldData)
		local buttondata = StringSplit(buttonId,":")
		local button = buttondata[1]
		local param = buttondata[2]
		if(button=="Create") then
			for k,v in pairs(CLIENTIDREFERENCE) do
				if(v.Name==param) then tableData = v end
			end			
        	user:RequestClientTargetLoc(this,"CreateObjectAt")
        	user:SystemMessage("select a location to place [FFFF00]"..param)
		end
		if(button=="Search") then
			ShowLeftPane(fieldData.search_query,leftPaneMinimized)
		end
	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"CreateObjectAt",
	function(success,location)
		if(success and location ~= nil) then
			if(tableData ~= nil) then
				local templateData = GetTemplateData("blank")
				templateData.Name = tableData.Name
				templateData.ClientId = tonumber(tableData.Id)
				CreateCustomObj("blank",templateData,location)
			end		
		end
	end)
----------------------------------------------------------------------------------------
--							 CREATE SPAWNER EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateSpawner",
 	function()
		this:RequestClientTargetLoc(this,"placeSpawner")
        this:SystemMessage("select a location to place the spawner")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeSpawner",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("spawner",location,"OnCreateSpawner")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeSpawner")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE REGION EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateRegion",
 	function()
		this:RequestClientTargetLoc(this,"placeRegion")
        this:SystemMessage("select a location to place the region")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeRegion",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("region",location,"OnCreateRegion")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeRegion")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE CreateMerchantMale EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateMerchantMale",
 	function()
		this:RequestClientTargetLoc(this,"placeMerchantMale")
        this:SystemMessage("select a location to place the merchant")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeMerchantMale",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("merchant_male",location,"OnCreateMerchantMale")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeMerchantMale")
		end
	end)

----------------------------------------------------------------------------------------
--							 CREATE CreateMerchantFemale EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateMerchantFemale",
 	function()
		this:RequestClientTargetLoc(this,"placeMerchantFemale")
        this:SystemMessage("select a location to place the merchant")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeMerchantFemale",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("merchant_female",location,"OnCreateMerchantFemale")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeMerchantFemale")
		end
	end)

----------------------------------------------------------------------------------------
--							 MoveObjectToLocation EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"MoveObjectToLocation",
 	function()
		this:RequestClientTargetGameObj(this,"targetObjectToMove")
        this:SystemMessage("select a target object to move")
 	end)

local objectMoveTarget = nil

RegisterEventHandler(EventType.ClientTargetGameObjResponse,"targetObjectToMove",
	function(object)
		if(object ~= nil) then
			this:RequestClientTargetLoc(this, "selectNewLocation")
			this:SystemMessage("select a location to move the object too")
			objectMoveTarget = object
		end
	end)

RegisterEventHandler(EventType.ClientTargetLocResponse, "selectNewLocation", 
	function(success,targetLoc,objecttarget)
		if(success and objecttarget ~= nil) then
			this:SystemMessage("try not to target another object please")
		end
		if(success and targetLoc ~= nil) then
			objectMoveTarget:SetWorldPosition(targetLoc)
		else
			this:SystemMessage("Something bad happened during the move, try again")
		end
	end)


----------------------------------------------------------------------------------------
--							 CREATE DUNGEON CONTROLLER EVENT HANDLERS
----------------------------------------------------------------------------------------
RegisterEventHandler(EventType.ClientUserCommand,"CreateDungeonController",
 	function()
		this:RequestClientTargetLoc(this,"placeDungeonController")
        this:SystemMessage("select a location to place the dungeon controller")
 	end)

RegisterEventHandler(EventType.ClientTargetLocResponse,"placeDungeonController",
	function(success,location)
		if(success and location ~= nil) then
			CreateObj("dungeon_controller",location,"OnCreateSpawner")
			PlayEffectAtLoc("TeleportFromEffect",location,0)
		else
			this:SystemMessage("[FF7700]ERROR: bad placement, try again")
			this:RequestClientTargetLoc(this,"placeDungeonController")
		end
	end)



RegisterEventHandler(EventType.ClientObjectCommand,"dropAction",
	function (user,sourceId,actionType,actionId,slot)
		-- print(user,sourceId,actionType,actionId,slot)

		if(actionType == "CreateSpawner" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateSpawner",
				ActionType="CreateSpawner",
				DisplayName="Create Spawner",
				Tooltip="This will create a spawner at the targeted location.",
				Icon="Magic Barrier",
				ServerCommand="CreateSpawner",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateSpawner" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end

		if(actionType == "CreateRegion" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateRegion",
				ActionType="CreateRegion",
				DisplayName="Create Region",
				Tooltip="This will create a region at the targeted location.",
				Icon="Night",
				ServerCommand="CreateRegion",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateRegion" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end
		
		if(actionType == "CreateMerchantMale" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateMerchantMale",
				ActionType="CreateMerchantMale",
				DisplayName="Create Male Merchant",
				Tooltip="This will create a new male merchant at the targeted location.",
				Icon="Fire Mastery",
				ServerCommand="CreateMerchantMale",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateMerchantMale" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end	
		if(actionType == "CreateMerchantFemale" and slot ~= nil) then
			local userAction = 
			{
				ID="CreateMerchantFemale",
				ActionType="CreateMerchantFemale",
				DisplayName="Create Female Merchant",
				Tooltip="This will create a new female merchant at the targeted location.",
				Icon="Unholy Mastery",
				ServerCommand="CreateMerchantFemale",
				Enabled=true
			}
			userAction.Slot = tonumber(slot)
			AddUserActionToSlot(userAction)
		end
		if(actionType=="CreateMerchantFemale" and slot == nil) then
			RemoveUserActionFromSlot(sourceId.Slot)
		end					
	end)


RegisterCommand{ Command="admin", AccessLevel = AccessLevel.God, Func=LoadProjectPhoenixUI, Desc="project phoenix administration dynamic window" }