-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
-----------------------------------------------------------------------------------
--							GLOBAL STYLES FOR QUEST DIALOGS
-----------------------------------------------------------------------------------

WindowStyles = {
	ErrorMessages = {MessageHue="FF0000",EnableMessages=true},
	CustomMerchantWindow =
	{
		default = 
		{		
			Skin = 
			{
				Left = {Image = "Blank", Color="221100",Trim={Image="",Color=""}},
				Right = {Image = "Blank", Color="221100",Trim={Image="",Color=""}},
				Top = {Image = "Blank", Color="221100",Trim={Image="SectionDividerFrames_nobackground",Color="FF7700"}},
				Bottom = {Image = "Blank", Color="221100",Trim={Image="SectionDividerFrames_nobackground",Color="FF7700"}},
			},
		}		
	},
	CustomQuestWindow = 
	{
		Default = {
			SkinLeft = "Blank",
			SkinMiddle = "Blank",
			SkinRight = "Blank",
			SkinTop = "Blank",
			SkinBottom = "Blank",
			SkinTrimTop="SectionDividerFrames_nobackground",
			SkinTrimBottom="SectionDividerFrames_nobackground",
			BorderLeft = "221100",
			BorderMiddle = "221100",
			BorderRight = "221100",
			BorderTop = "221100",
			BorderBottom = "221100",
			TrimTop = "FF7700",
			TrimBottom = "FF7700",
			PortraitBackImage1 = {Image="SkillTracker_BG",ImageHue="333355"},
			PortraitBackImage2 = {Image="magicalguide",ImageHue="153045"},
			NameBarHue = "996633",
			NameBarTextHue = "EECC33",
			NameBarSkin = "Tab_Bar",
			QuestButtonTextColor = "FF7700",
			QuestButtonBackImage = {Image="TitleBackground",ImageHue="FF7700"},
			QuestButtonTooltip = {TitleColor="FF7700",TextColor="EECC33"},
			IntroDialogTextColor = "DDBB44",
			--start of questlog extras
			QuestButton = {Image="TitleBackground",ImageColor="556699",TextColor="556699",CompletedImageColor="559966",CompletedTextColor="559966",IsActiveImageColor="EEBB00",IsActiveTextColor="EEBB00"},
			QuestDescription = {TextColor="CCAA22"},
			QuestSlayTask = {TaskTextColor="556699",CompletedTextColor="EEBB00",CheckMarkColor="556699",BackGround="TitleBackground",BackgroundColor="556699",CheckMarkImage="Checkmark"},
		},
	}	
}

-----------------------------------------------------------------------------------
--									FUNCTIONS
-----------------------------------------------------------------------------------
function ShowIntroWindow(user, merchant,style)
	if(IsGod(user)) then
		if(WindowStyles.CustomQuestWindow[style]==nil) then 
			if(WindowStyles.ErrorMessages.EnableMessages)then
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.","info")
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.")
			end
			style ="Default" 
		end
		if(merchant:GetObjVar("Dialogs_Intro") == nil or merchant:GetObjVar("Dialogs_Intro") == "") then
			if(WindowStyles.ErrorMessages.EnableMessages)then
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]Object Variable:Dialogs_Intro missing or nil. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading default intro text instead.","info")
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]Object Variable:Dialogs_Intro missing or nil. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading default intro text instead.")
			end
			merchant:SetObjVar("Dialogs_Intro","I see that you are looking to partake in some good adventures my dear friend. I just so happen to have a few things I want handled around here if you are keen. These are the tasks I have available for you to choose from. Which will it be?")
		end
	end
	local window = DynamicWindow("QuestIntroDialog","",590,260,-300,-130,"Default","Center")
	--leftbar
	window:AddImage(-13,-15,WindowStyles.CustomQuestWindow[style].SkinLeft,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderLeft)
	window:AddImage(-17,-15,"SearchBarFrame",15,232,"Sliced","FF9900")

	--righttbar
	window:AddImage(564,-15,WindowStyles.CustomQuestWindow[style].SkinRight,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderRight)
	window:AddImage(564,-15,"SearchBarFrame",15,232,"Sliced","FF9900")

	--merchant portrait	
	window:AddImage(0,0,WindowStyles.CustomQuestWindow[style].PortraitBackImage1.Image,190,190,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage1.ImageHue)
	window:AddImage(10,13,WindowStyles.CustomQuestWindow[style].PortraitBackImage2.Image,170,170,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage2.ImageHue)
	local dressmode = merchant:GetObjVar("DressMode") or false
	if(dressmode) then
		window:AddPortrait(5,8,180,180,merchant,"full")
		window:AddImage(16,119,"Checkbox32px_On",24,24,"Sliced","00AA00")
		window:AddButton(10,113,"ToggleDressMode","",24,24,"[FF7700]Dress Mode[CCAA22]\nclick to toggle dress mode On and Off.",nil,true,"Invisible")		
	else
		window:AddPortrait(5,8,180,180,merchant,"head")
		window:AddImage(16,119,"Checkbox32px_Off",24,24,"Sliced","006600")
		window:AddButton(10,113,"ToggleDressMode","",24,24,"[FF7700]Dress Mode[CCAA22]\nclick to toggle dress mode On and Off.",nil,true,"Invisible")		
	end
	if(IsGod(user)) then
		window:AddImage(4,144,"Skill_Melee",42,42,"Sliced","151515")
		window:AddImage(10,150,"Skill_Melee",32,32,"Sliced","FFFFFF")
		window:AddButton(4,144,"OpenCustomWindow","",42,42,"[FF7700]Appearance Window[CCAA22]\nclick this to customize the quest giver's appearance.",nil,false,"Invisible")
	end
	--top bar
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].BorderTop)
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTrimTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].TrimTop)
	--merchant name bar
	window:AddImage(105,-47,WindowStyles.CustomQuestWindow[style].NameBarSkin,370,55,"Sliced",WindowStyles.CustomQuestWindow[style].NameBarHue)
	window:AddLabel(291,-32,"[".. WindowStyles.CustomQuestWindow[style].NameBarTextHue .. "]"..StripColorFromString(merchant:GetName()),360,28,28,"center",false,false,"PermianSlabSerif_16_Dynamic")
	--bottom bar
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].BorderBottom)
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinTrimTop,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].TrimBottom)


	--show player the opening dialog text
	window:AddLabel(192,10,"[".. WindowStyles.CustomQuestWindow[style].IntroDialogTextColor .. "]"..merchant:GetObjVar("Dialogs_Intro"),370,200,20,"left",false,false,"PermianSlabSerif_16_Dynamic")

 	--show player their quest options
	local quest_list = merchant:GetObjVar("Quests_ListToOfferPlayer")

	--if the player does not have the requirements, do not add them to the list
	local passed_requirements_list = {}
	for i,val in pairs(quest_list) do
		if(CustomQuests.Quests[val].Requirements ~= nil) then
			if(CustomQuests.Quests[val].Requirements.Check(user,this,val)) then
				table.insert(passed_requirements_list,val)
			end
		else
			table.insert(passed_requirements_list,val)
		end
	end
	
	for i,val in pairs(passed_requirements_list) do
		--makeshift button background
		window:AddImage(192,82+(i*26),WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,370,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
		--button text
		window:AddLabel(202,86+(i*26),"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]"..CustomQuests.Quests[val].Title,320,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
		
		--does player have quest if so.. display it on the menu to them
		if(CustomQuests.Helpers.IsQuestComplete(user,val)) then
			window:AddImage(542,88+(i*26),"Blank",14,14,"Sliced","008800")
			--invisible button overlay
			window:AddButton(192,82+(i*26),"ViewQuest:"..val,"",360,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[val].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nClick this to turn in this [b]Quest[/b] for [i]"..StripColorFromString(merchant:GetName()).."[/i]",nil,true,"Invisible")
		else
			if(CustomQuests.Helpers.HasQuest(user,val)) then
				window:AddImage(542,88+(i*26),"Blank",14,14,"Sliced","888800")
				window:AddButton(192,82+(i*26),"NoHandlerNeeded","",360,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[val].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nYou already have this [b]Quest[/b] from [i]"..StripColorFromString(merchant:GetName()) .. "[/i] in your quest log.",nil,false,"Invisible")			
			else
				window:AddImage(542,88+(i*26),"Blank",14,14,"Sliced","880000")			
				window:AddButton(192,82+(i*26),"ViewQuest:"..val,"",360,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[val].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nClick this to learn more about this [b]Quest[/b] from [i]"..StripColorFromString(merchant:GetName()).."[/i]",nil,true,"Invisible")
			end
		end	
	end
	window:AddImage(552,-22,"blank",26,26,"Sliced","151515")
	window:AddImage(554,-20,"blank",22,22,"Sliced","906030")
	window:AddButton(552,-24,"","Button",28,28,"[FF7700]Close Window",nil,true,"Invisible")
	window:AddLabel(559,-18,"[AA0000]X",24,24,24,"",false,false,"PermianSlabSerif_16_Dynamic")
 
	user:OpenDynamicWindow(window,merchant)
end

function ShowQuestDialog(user,merchant,quest,style)
	if(IsGod(user)) then
		if(WindowStyles.CustomQuestWindow[style]==nil) then 
			if(WindowStyles.ErrorMessages.EnableMessages)then
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.","info")
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.")
			end
			style ="Default" 
		end
	end
	local window = DynamicWindow("QuestIntroDialog","",590,260,-300,-130,"Default","Center")
	--leftbar
	window:AddImage(-13,-15,WindowStyles.CustomQuestWindow[style].SkinLeft,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderLeft)
	--righttbar
	window:AddImage(564,-15,WindowStyles.CustomQuestWindow[style].SkinRight,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderRight)
	--merchant portrait	
	window:AddImage(0,0,WindowStyles.CustomQuestWindow[style].PortraitBackImage1.Image,190,190,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage1.ImageHue)
	window:AddImage(10,13,WindowStyles.CustomQuestWindow[style].PortraitBackImage2.Image,170,170,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage2.ImageHue)
	window:AddPortrait(5,8,180,180,merchant,"head")

	--top bar
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].BorderTop)
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTrimTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].TrimTop)

	--merchant name bar
	window:AddImage(105,-47,WindowStyles.CustomQuestWindow[style].NameBarSkin,370,55,"Sliced",WindowStyles.CustomQuestWindow[style].NameBarHue)
	window:AddLabel(291,-32,"[".. WindowStyles.CustomQuestWindow[style].NameBarTextHue .. "]"..StripColorFromString(merchant:GetName()),360,28,28,"center",false,false,"PermianSlabSerif_16_Dynamic")

	--bottom bar
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].BorderBottom)
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinTrimBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].TrimBottom)

	--show the quest description
	window:AddLabel(192,10,"[".. WindowStyles.CustomQuestWindow[style].IntroDialogTextColor .. "]"..CustomQuests.Quests[quest].Description,370,200,20,"left",false,false,"PermianSlabSerif_16_Dynamic")


	--decline the quest button
	--invisible button overlay
	window:AddButton(195,160,"DeclineQuest:"..quest,"",120,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[quest].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will decline this quest from "..StripColorFromString(merchant:GetName()),nil,true,"Invisible")
	--makeshift button background
	window:AddImage(192,160,WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,120,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
	--button text
	window:AddLabel(222,164,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]Decline",120,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")	

	--accept the quest button
	window:AddButton(442,160,"AcceptQuest:"..quest,"",120,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[quest].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will accept the quest "..StripColorFromString(merchant:GetName()),nil,true,"Invisible")
	--makeshift button background
	window:AddImage(442,160,WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,120,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
	--button text
	window:AddLabel(477,164,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]Accept",120,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")	

	--ohhh looky looky
	user:OpenDynamicWindow(window,merchant)
end	

function ShowQuestFinishDialog(user,merchant,quest,style)
	if(IsGod(user)) then
		if(WindowStyles.CustomQuestWindow[style]==nil) then 
			if(WindowStyles.ErrorMessages.EnableMessages)then
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.","info")
				user:SystemMessage("\n[".. WindowStyles.ErrorMessages.MessageHue .. "]ERROR: [FFAA33]WindowStyles.CustomQuestWindow."..style.." not found. \n[".. WindowStyles.ErrorMessages.MessageHue ..  "]ACTION: [FFAA33]Loading WindowStyles.CustomQuestWindow.Default instead.")
			end
			style ="Default" 
		end
	end
	local window = DynamicWindow("QuestIntroDialog","",590,260,-300,-130,"Default","Center")
	--leftbar
	window:AddImage(-13,-15,WindowStyles.CustomQuestWindow[style].SkinLeft,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderLeft)
	--righttbar
	window:AddImage(564,-15,WindowStyles.CustomQuestWindow[style].SkinRight,15,232,"Sliced",WindowStyles.CustomQuestWindow[style].BorderRight)
	--merchant portrait	
	window:AddImage(0,0,WindowStyles.CustomQuestWindow[style].PortraitBackImage1.Image,190,190,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage1.ImageHue)
	window:AddImage(10,13,WindowStyles.CustomQuestWindow[style].PortraitBackImage2.Image,170,170,"Sliced",WindowStyles.CustomQuestWindow[style].PortraitBackImage2.ImageHue)
	window:AddPortrait(5,8,180,180,merchant,"head")

	--top bar
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].BorderTop)
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTrimTop,600,40,"Sliced",WindowStyles.CustomQuestWindow[style].TrimTop)

	--merchant name bar
	window:AddImage(105,-47,WindowStyles.CustomQuestWindow[style].NameBarSkin,370,55,"Sliced",WindowStyles.CustomQuestWindow[style].NameBarHue)
	window:AddLabel(291,-32,"[".. WindowStyles.CustomQuestWindow[style].NameBarTextHue .. "]"..StripColorFromString(merchant:GetName()),360,28,28,"center",false,false,"PermianSlabSerif_16_Dynamic")

	--bottom bar
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].BorderBottom)
	window:AddImage(-17, 189,WindowStyles.CustomQuestWindow[style].SkinTrimBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].TrimBottom)

	--show the quest description
	window:AddLabel(192,10,"[".. WindowStyles.CustomQuestWindow[style].IntroDialogTextColor .. "]"..CustomQuests.Quests[quest].QuestCompletedMessage,370,200,20,"left",false,false,"PermianSlabSerif_16_Dynamic")


	--decline the quest button
	--invisible button overlay
	--window:AddButton(195,160,"DeclineQuest:"..quest,"",120,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[quest].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will decline this quest from "..StripColorFromString(merchant:GetName()),nil,true,"Invisible")
	--makeshift button background
	--window:AddImage(192,160,WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,120,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
	--button text
	--window:AddLabel(222,164,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]Decline",120,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")	

	--accept the quest button
	window:AddButton(442,160,"CompleteQuest:"..quest,"",120,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..CustomQuests.Quests[quest].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will complete the\nquest and give you your rewards\nfrom  "..StripColorFromString(merchant:GetName()),nil,true,"Invisible")
	--makeshift button background
	window:AddImage(442,160,WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,120,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
	--button text
	window:AddLabel(467,164,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]Complete",120,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")	

	--my styles bring all the boys to the yard and their like, its 
	--better then yours...I can teach you but id have to charge...
	user:OpenDynamicWindow(window,merchant)
end	

function ShowQuestLog(user,quest_to_view)
	if not(user:HasObjVar("Quests_QuestLog")) then
		user:SetObjVar("Quests_QuestLog",{})
	end
	local style = "Default"
	local window = DynamicWindow("QuestLog","",590,540,-300,-280,"Default","Center")
	--left bar
	window:AddImage(-13,-15,WindowStyles.CustomQuestWindow[style].SkinLeft,15,510,"Sliced",WindowStyles.CustomQuestWindow[style].BorderLeft)
	--middle bar
	window:AddImage(234,-15,WindowStyles.CustomQuestWindow[style].SkinMiddle,15,510,"Sliced",WindowStyles.CustomQuestWindow[style].BorderMiddle)
	--rightt bar
	window:AddImage(564,-15,WindowStyles.CustomQuestWindow[style].SkinRight,15,510,"Sliced",WindowStyles.CustomQuestWindow[style].BorderRight)
	--top bar
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTop,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].BorderTop)
	window:AddImage(-17,-30,WindowStyles.CustomQuestWindow[style].SkinTrimTop,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].TrimTop)
	--quest log bar
	window:AddImage(105,-47,WindowStyles.CustomQuestWindow[style].NameBarSkin,370,55,"Sliced",WindowStyles.CustomQuestWindow[style].NameBarHue)
	window:AddLabel(291,-32,"[".. WindowStyles.CustomQuestWindow[style].NameBarTextHue .. "]Quest Log",360,28,28,"center",false,false,"PermianSlabSerif_16_Dynamic")
	--bottom bar
	window:AddImage(-17, 469,WindowStyles.CustomQuestWindow[style].SkinBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].BorderBottom)
	window:AddImage(-17, 469,WindowStyles.CustomQuestWindow[style].SkinTrimBottom,600,35,"Sliced",WindowStyles.CustomQuestWindow[style].TrimBottom)

	--quest log list on left side
	local scrollWindow = ScrollWindow(10,10,204,440,40)
	local quest_log = user:GetObjVar("Quests_QuestLog")
	for i,val in pairs(quest_log) do
		local scrollElement = ScrollElement()
		if(i == quest_to_view) then 
			--accept the quest button
			scrollElement:AddButton(1,1,"DisplayInfo:"..i,"",192,38,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]" .. quest_log[i].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will allow you to\nview the quest information for\nthis quest",nil,true,"Invisible")
			--makeshift button background
			scrollElement:AddImage(1,1,WindowStyles.CustomQuestWindow[style].QuestButton.Image,192,38,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButton.IsActiveImageColor)
			--button text
			scrollElement:AddLabel(10,10,"[".. WindowStyles.CustomQuestWindow[style].QuestButton.IsActiveTextColor .. "]" .. quest_log[i].Title,183,16,16,"left",false,false,"PermianSlabSerif_16_Dynamic")	
		else
			if(CustomQuests.Helpers.IsQuestComplete(user,i)) then		
				--accept the quest button
				scrollElement:AddButton(1,1,"DisplayInfo:"..i,"",192,38,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]" .. quest_log[i].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will allow you to\nview the quest information for\nthis quest",nil,true,"Invisible")
				--makeshift button background
				scrollElement:AddImage(1,1,WindowStyles.CustomQuestWindow[style].QuestButton.Image,192,38,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButton.CompletedImageColor)
				--button text
				scrollElement:AddLabel(10,10,"[".. WindowStyles.CustomQuestWindow[style].QuestButton.CompletedTextColor .. "]" .. quest_log[i].Title,183,16,16,"left",false,false,"PermianSlabSerif_16_Dynamic")	
			else
				--accept the quest button
				scrollElement:AddButton(1,1,"DisplayInfo:"..i,"",192,38,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]" .. quest_log[i].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will allow you to\nview the quest information for\nthis quest",nil,true,"Invisible")
				--makeshift button background
				scrollElement:AddImage(1,1,WindowStyles.CustomQuestWindow[style].QuestButton.Image,192,38,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButton.ImageColor)
				--button text
				scrollElement:AddLabel(10,10,"[".. WindowStyles.CustomQuestWindow[style].QuestButton.TextColor .. "]" .. quest_log[i].Title,183,16,16,"left",false,false,"PermianSlabSerif_16_Dynamic")	
			end
		end
		scrollWindow:Add(scrollElement)
	end
	--create right side data if they clicked a button
	if(quest_to_view ~= nil) then
		--Quest Description
		window:AddLabel(260,20,"[".. WindowStyles.CustomQuestWindow[style].QuestDescription.TextColor .. "]" .. CustomQuests.Quests[quest_to_view].Description,300,300,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
		--display tasks
		local quest_log = user:GetObjVar("Quests_QuestLog")

		--decline the quest button
		window:AddButton(438,435,"Decline:"..quest_to_view,"",120,24,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TitleColor .. "]"..quest_log[quest_to_view].Title .. "[".. WindowStyles.CustomQuestWindow[style].QuestButtonTooltip.TextColor .. "]\nclicking this will [b]abandon[/b] this quest ",nil,true,"Invisible")
		--makeshift button background
		window:AddImage(438,435,WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.Image,120,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestButtonBackImage.ImageHue)
		window:AddLabel(470,440,"[".. WindowStyles.CustomQuestWindow[style].QuestButtonTextColor .. "]Abandon",120,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")

		for i,val in pairs(CustomQuests.Quests[quest_to_view].Tasks) do
			if(val[1]=="slay") then
				local text = val[6]
				if(val[3] > 1) then text = val[6].."'s" end
				--if the task is complete then display checkbox with UI
				--also change text hue to reflect the quest is done.
				--QuestSlayTask = {TaskTextColor="556699",CompletedTextColor="EEBB00",CheckMarkColor="556699",BackGround="TitleBackground",BackgroundColor="556699"},
				if(quest_log[quest_to_view].Tasks[i][4] >= val[3]) then
    				--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. "Slay " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--since this objective is complete, show in the interface
					window:AddImage(498,303+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkImage,18,18,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkColor)
				else
					--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. "Slay " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				end
			elseif(val[1]=="harvest") then
				local text = val[6]
				if(val[3] > 1) then text = val[6].."'s" end
				--if the task is complete then display checkbox with UI
				--also change text hue to reflect the quest is done.
				--QuestSlayTask = {TaskTextColor="556699",CompletedTextColor="EEBB00",CheckMarkColor="556699",BackGround="TitleBackground",BackgroundColor="556699"},
				if(quest_log[quest_to_view].Tasks[i][4] >= val[3]) then
    				--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. "Harvest " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--since this objective is complete, show in the interface
					window:AddImage(498,303+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkImage,18,18,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkColor)
				else
					--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. "Harvest " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				end				
			elseif(val[1]=="tame") then
				local text = val[6]
				if(val[3] > 1) then text = val[6].."'s" end
				--if the task is complete then display checkbox with UI
				--also change text hue to reflect the quest is done.
				--QuestSlayTask = {TaskTextColor="556699",CompletedTextColor="EEBB00",CheckMarkColor="556699",BackGround="TitleBackground",BackgroundColor="556699"},
				if(quest_log[quest_to_view].Tasks[i][4] >= val[3]) then
    				--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. "Tame " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--since this objective is complete, show in the interface
					window:AddImage(498,303+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkImage,18,18,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkColor)
				else
					--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. "Tame " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				end	
				elseif(val[1]=="craft") then
				local text = val[6]
				if(val[3] > 1) then text = val[6].."'s" end
				--if the task is complete then display checkbox with UI
				--also change text hue to reflect the quest is done.
				--QuestSlayTask = {TaskTextColor="556699",CompletedTextColor="EEBB00",CheckMarkColor="556699",BackGround="TitleBackground",BackgroundColor="556699"},
				if(quest_log[quest_to_view].Tasks[i][4] >= val[3]) then
    				--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. "Craft " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.CompletedTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--since this objective is complete, show in the interface
					window:AddImage(498,303+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkImage,18,18,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.CheckMarkColor)
				else
					--task background
					window:AddImage(258,298+(i*28),WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGround,304,28,"Sliced",WindowStyles.CustomQuestWindow[style].QuestSlayTask.BackGroundColor)
					--task description
					window:AddLabel(262,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. "Craft " .. val[3] .. " ".. text,300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
					--task counter
					window:AddLabel(520,303+(i*28),"[".. WindowStyles.CustomQuestWindow[style].QuestSlayTask.TaskTextColor .. "]" .. quest_log[quest_to_view].Tasks[i][4] .. "/"..val[3],300,20,20,"left",false,false,"PermianSlabSerif_16_Dynamic")
				end											
			end					
		end
	end
	window:AddScrollWindow(scrollWindow)
	--show the user our fancy work here.... 
	user:OpenDynamicWindow(window,user)
end




	