-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'region_dynamic_window'
require 'region_save_to_xml'
------------------------------------------------------------------
-- @function UpdateToolTip()
-- updates the tooltip for the region_controller object
------------------------------------------------------------------
function UpdateToolTip()
	if(#this:GetObjVar("PlayersInRegion") > 0) then
		SetTooltipEntry(this,"current_player_count","[336699]Players:[666699]"..#this:GetObjVar("PlayersInRegion"),101)	
	else
		RemoveTooltipEntry(this,"current_player_count")
	end
	if(#this:GetObjVar("MobilesInRegion") > 0) then
		SetTooltipEntry(this,"current_mob_count","[336699]Mobiles:[666699]"..#this:GetObjVar("MobilesInRegion"),100)
	else
		RemoveTooltipEntry(this,"current_mob_count")
	end
	if(#this:GetObjVar("ObjectsInRegion") > 0) then
		SetTooltipEntry(this,"current_object_count","[336699]Objects:[666699]"..#this:GetObjVar("ObjectsInRegion"),99)
	else
		RemoveTooltipEntry(this,"current_object_count")
	end
	SetTooltipEntry(this,"bottomspace","",3)
	if(this:GetObjVar("Active") == true) then
		SetTooltipEntry(this,"active","[00FF77]Active",2)
	else
		SetTooltipEntry(this,"active","[FF0000]Offline",2)
	end
    if(ProjectPhoenix ~= nil) then
		ProjectPhoenix.ApplyTooltip(this)     
    end 	
end
------------------------------------------------------------------
-- @function GetBoundries(args)
-- @param args - the arugments in which mode your getting the
--               boundries.
--		*true will set a basic bounding box 5 unites in each 
--       direction.
--      *AdjustRegion is fired and sent as an arugment when 
--       you use the Adjust Regions context menu option. it
--       rebuilds the bounds based on your two target locations.
------------------------------------------------------------------
function GetBoundries(args)
	--if the custom spawner was just created, then
	--give us a generic boundry with a range of 5
	local location = this:GetLoc()
	if(args == true) then
		local range = 5
		local topLeft = Loc2(location.X-range,location.Z-range)
		local topRight = Loc2(location.X+range,location.Z-range)
		local bottomRight = Loc2(location.X+range,location.Z+range)
		local bottomLeft = Loc2(location.X-range,location.Z+range)
		this:SetObjVar("Bounds_X",topLeft.X)
		this:SetObjVar("Bounds_Z",topLeft.Z)
		this:SetObjVar("Bounds_Width",11)
		this:SetObjVar("Bounds_Height",11)
		this:SetObjVar("Bounds_Area",Box2(topLeft,topRight,bottomLeft,bottomRight))
		return Box2(topLeft,topRight,bottomLeft,bottomRight)
	elseif(args == "AdjustRegion") then
		local loc1 = this:GetObjVar("temp_coord_storage1") or Loc2(location.X-5,location.Z-5)
		local loc2 = this:GetObjVar("temp_coord_storage2") or Loc2(location.X+5,location.Z+5)
		local startLocation = Loc2(0,0,0)
		local regionWidth = 0
		local regionHeight = 0
		if(loc1.X < loc2.X) then 
			startLocation.X = loc1.X
			regionWidth = loc2.X - loc1.X 
		else 
			startLocation.X = loc2.X 
			regionWidth = loc1.X - loc2.X
		end
		if(loc1.Z < loc2.Z) then 
			startLocation.Z = loc1.Z
			regionHeight = loc2.Z - loc1.Z 
		else 
			startLocation.Z = loc2.Z 
			regionHeight = loc1.Z - loc2.Z
		end

		local topLeft = Loc2(startLocation.X,startLocation.Z)
		local topRight = Loc2(startLocation.X+regionWidth,startLocation.Z)
		local bottomRight = Loc2(startLocation.X+regionWidth,startLocation.Z+regionHeight)
		local bottomLeft = Loc2(startLocation.X,startLocation.Z+regionHeight)

		this:SetObjVar("Bounds_X",topLeft.X)
		this:SetObjVar("Bounds_Z",topLeft.Z)
		this:SetObjVar("Bounds_Width",regionWidth)
		this:SetObjVar("Bounds_Height",regionHeight)
		this:SetObjVar("Bounds_Area",Box2(topLeft,topRight,bottomLeft,bottomRight))

		return Box2(topLeft,topRight,bottomLeft,bottomRight)
	elseif(args == "init") then
		local startLocation = Loc2(this:GetObjVar("Bounds_X"),0,this:GetObjVar("Bounds_Z"))
		local regionWidth = tonumber(this:GetObjVar("Bounds_Width"))
		local regionHeight = tonumber(this:GetObjVar("Bounds_Height"))

		local topLeft = Loc2(startLocation.X,startLocation.Z)
		local topRight = Loc2(startLocation.X+regionWidth,startLocation.Z)
		local bottomRight = Loc2(startLocation.X+regionWidth,startLocation.Z+regionHeight)
		local bottomLeft = Loc2(startLocation.X,startLocation.Z+regionHeight)
		this:SetObjVar("Bounds_Area",Box2(topLeft,topRight,bottomLeft,bottomRight))
		return Box2(topLeft,topRight,bottomLeft,bottomRight)
	end	
end
----------------------------------------------------------
--EVENTTYPE - ModuleAttached 
----------------------------------------------------------
RegisterSingleEventHandler(EventType.ModuleAttached, GetCurrentModule(), 
function()
	if(initializer.MessageTypeInfo ~= nil) then
			this:SetObjVar("MessageTypeInfo",initializer.MessageTypeInfo)
	else
			this:SetObjVar("MessageTypeInfo",{OnEnter = {System="pressed",Info="",Event=""},OnExit = {System="pressed",Info="",Event=""},})			
	end
	if(initializer ~= nil) then
		this:SetObjVar("OnEnter_AddModToPlayer",initializer.OnEnterPlayer or {})
		this:SetObjVar("OnEnter_AddModToMobile",initializer.OnEnterMobile or {})
		this:SetObjVar("OnExit_AddModToPlayer",initializer.OnExitPlayer or {})
		this:SetObjVar("OnExit_AddModToMobile",initializer.OnExitMobile or {})
		local BoundsInit = false
		if(initializer.RegionBounds ~= nil) then
			this:SetObjVar("Bounds_X",initializer.RegionBounds.Bounds_X)
			this:SetObjVar("Bounds_Z",initializer.RegionBounds.Bounds_Z)
			this:SetObjVar("Bounds_Width",initializer.RegionBounds.Bounds_Width)
			this:SetObjVar("Bounds_Height",initializer.RegionBounds.Bounds_Height)
			AddView("RegionView", SearchRect(GetBoundries("init")),this:GetObjVar("HeartBeat_Speed") or 0.1)
			BoundsInit = true
		end
		if(BoundsInit == false) then
			if(this:HasObjVar("Bounds_Area") == true) then
				AddView("RegionView", SearchRect(GetBoundries()),this:GetObjVar("HeartBeat_Speed") or 0.1)
			else
				AddView("RegionView", SearchRect(GetBoundries(true)),this:GetObjVar("HeartBeat_Speed") or 0.1)
			end
		end
	else
		this:SetObjVar("OnEnter_AddModToPlayer",{})
		this:SetObjVar("OnEnter_AddModToMobile",{})
		this:SetObjVar("OnExit_AddModToPlayer",{})
		this:SetObjVar("OnExit_AddModToMobile",{})
		AddView("RegionView", SearchRect(GetBoundries(true)),this:GetObjVar("HeartBeat_Speed") or 0.1)
	end
	this:SetObjVar("PlayersInRegion",{})
	this:SetObjVar("MobilesInRegion",{})
	this:SetObjVar("ObjectsInRegion",{})
	AddUseCase(this,"[FF7700]-|Project Phoenix|-",false)
	AddUseCase(this,"[CCCC44]Open Editor",true)
	AddUseCase(this,"[CCCC44]Adjust Region",false)
	AddUseCase(this,"[CCCC44]Refresh Modules",false)
	UpdateToolTip()
end)

----------------------------------------------------------
--EVENTTYPE - Message "UseObject" 
----------------------------------------------------------
RegisterEventHandler(EventType.Message, "UseObject", function(user,usedType)
	if(usedType=="[CCCC44]Adjust Region") then
		user:RequestClientTargetLoc(this,"firstBoundryPoint")
    	user:SystemMessage("select the first bounding box point")
    end
    if(usedType=="[CCCC44]Open Editor") then
    	DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
    end
    if(usedType=="[CCCC44]Refresh Modules") then
    	ReloadModule("region")
    end
end)

----------------------------------------------------------
--EVENTTYPE - EnterView 
----------------------------------------------------------
RegisterEventHandler(EventType.EnterView, "RegionView", function (object)
	if(this:GetObjVar("Active") == false) then return end

	if(object:IsPlayer() and this:GetObjVar("OnEnter_Message") ~= nil and this:GetObjVar("OnEnter_Message") ~= "") then
		local mobiles = this:GetObjVar("PlayersInRegion")
		table.insert(mobiles,object.Id)
		this:SetObjVar("PlayersInRegion",mobiles)		
		local messageTypes = this:GetObjVar("MessageTypeInfo")
		if(messageTypes.OnEnter.System=="pressed") then
			object:SystemMessage(this:GetObjVar("OnEnter_Message"),"")
		end
		if(messageTypes.OnEnter.Info=="pressed") then
			object:SystemMessage(this:GetObjVar("OnEnter_Message"),"info")
		end
		if(messageTypes.OnEnter.Event=="pressed") then
			object:SystemMessage(this:GetObjVar("OnEnter_Message"),"event")
		end
		for k,v in pairs(this:GetObjVar("OnEnter_AddModToPlayer")) do
			if not(object:HasModule(v) == true) then
				object:AddModule(v,{Region=this})
			end
		end		
	elseif(not object:IsPlayer() and object:IsMobile()) then
		local mobiles = this:GetObjVar("MobilesInRegion")
		table.insert(mobiles,object.Id)
		this:SetObjVar("MobilesInRegion",mobiles)
		for k,v in pairs(this:GetObjVar("OnEnter_AddModToMobile")) do
			if not(object:HasModule(v) == true) then
				object:AddModule(v,{Region=this})
			end
		end			
	else
		--must be an item
		local objects = this:GetObjVar("ObjectsInRegion")
		table.insert(objects,object.Id)
		this:SetObjVar("ObjectsInRegion",objects)		
	end
	UpdateToolTip()
end)

----------------------------------------------------------
--EVENTTYPE - LeaveView 
----------------------------------------------------------
RegisterEventHandler(EventType.LeaveView, "RegionView", function (object)
	if(this:GetObjVar("Active") == false) then return end
	if(object:IsPlayer() and this:GetObjVar("OnExit_Message") ~= nil and this:GetObjVar("OnExit_Message") ~= "") then
		local messageTypes = this:GetObjVar("MessageTypeInfo")
		if(messageTypes.OnExit.System=="pressed") then
			object:SystemMessage(this:GetObjVar("OnExit_Message"),"")
		end
		if(messageTypes.OnExit.Info=="pressed") then
			object:SystemMessage(this:GetObjVar("OnExit_Message"),"info")
		end
		if(messageTypes.OnExit.Event=="pressed") then
			object:SystemMessage(this:GetObjVar("OnExit_Message"),"event")
		end
	end
	if(object:IsMobile() == true) then
		
		if(object:IsPlayer() == true) then
			for k,v in pairs(this:GetObjVar("OnEnter_AddModToPlayer")) do
				if (object:HasModule(v) == true) then
					object:SendMessage("end_region_buff_effect")
				end
			end
			for k,v in pairs(this:GetObjVar("OnExit_AddModToPlayer")) do
				if not(object:HasModule(v) == true) then
					object:AddModule(v,{Region=this})
				end
			end
			local mobiles = this:GetObjVar("PlayersInRegion")
			for k,v in pairs(mobiles) do
				if(object.Id==v) then
					table.remove(mobiles,k)
				end
			end
			this:SetObjVar("PlayersInRegion",mobiles)				
		else
			local mobiles = this:GetObjVar("MobilesInRegion")
			for k,v in pairs(this:GetObjVar("OnEnter_AddModToMobile")) do
				if (object:HasModule(v) == true) then
					object:SendMessage("end_region_buff_effect")
				end
			end
			for k,v in pairs(this:GetObjVar("OnExit_AddModToMobile")) do
				if not(object:HasModule(v) == true) then
					object:AddModule(v,{Region=this})
				end
			end		
			for k,v in pairs(mobiles) do
				if(object.Id==v) then
					table.remove(mobiles,k)
				end
			end	
			this:SetObjVar("MobilesInRegion",mobiles)			
		end		
	else
		local objects = this:GetObjVar("ObjectsInRegion")
		for k,v in pairs(objects) do
			if(object.Id==v) then
				table.remove(objects,k)
			end
		end
		this:SetObjVar("ObjectsInRegion",objects)
	end
	UpdateToolTip()
end)

----------------------------------------------------------
--EVENTTYPE - ClientTargetLocResponse - bound box pick 1 
----------------------------------------------------------
RegisterEventHandler(EventType.ClientTargetLocResponse,"firstBoundryPoint", function(success,targetLoc,targetObj,user)
	if(targetObj == nil) then
		this:SetObjVar("temp_coord_storage1",targetLoc)
		user:RequestClientTargetLoc(this,"secondBoundryPoint")
    	user:SystemMessage("select the second bounding box point")
    else
    	user:SystemMessage("[FF7700][b]Error[/b]:[DDCC11][i]targeting objects and using it's coords is currently not supported. You have to click basic land.[/i]")
    end	
end)

----------------------------------------------------------
--EVENTTYPE - ClientTargetLocResponse - bound box pick 2 
----------------------------------------------------------
RegisterEventHandler(EventType.ClientTargetLocResponse,"secondBoundryPoint", function(success,targetLoc,targetObj,user)
	if(targetObj == nil) then
		this:SetObjVar("temp_coord_storage2",targetLoc)
		DelView("RegionView")
		AddView("RegionView", SearchRect(GetBoundries("AdjustRegion")),this:GetObjVar("HeartBeat_Speed") or 0.1)
	else
    	user:SystemMessage("[FF7700][b]Error[/b]:[DDCC11][i]targeting objects and using it's coords is currently not supported. You have to click basic land.[/i]")
	end
end)
----------------------------------------------------------
--EVENTTYPE - LoadedFromBackup 
----------------------------------------------------------
RegisterEventHandler(EventType.LoadedFromBackup,"",function()
	if (this:HasObjVar("Bounds_Area")) then
		this:SetObjVar("Bounds_Area",GetBoundries("AdjustRegion"))
		AddView("RegionView", SearchRect(this:GetObjVar("Bounds_Area")),this:GetObjVar("HeartBeat_Speed") or 0.1)
	else
		local bounds = GetBoundries(true)
		this:SetObjVar("Bounds_Area",bounds)
		AddView("RegionView", SearchRect(bounds),this:GetObjVar("HeartBeat_Speed") or 0.1)
	end
	this:SetObjVar("MobilesInRegion",{})
	this:SetObjVar("ObjectsInRegion",{})
	this:SetObjVar("PlayersInRegion",{})
	if(ProjectPhoenix ~= nil) then
		ProjectPhoenix.ApplyVersionInfo(this)
	end	
end)
----------------------------------------------------------
--EVENTTYPE - DynamicWindowResponse 
----------------------------------------------------------
RegisterEventHandler(EventType.DynamicWindowResponse,"RegionWindow",
function (user,buttonId,fieldData)
	local data = StringSplit(buttonId,":")
	local button = data[1]
	local params = data[2]
	if(button=="TogglePower") then
		this:SetObjVar("Active",not this:GetObjVar("Active"))
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
		if(this:GetObjVar("Active")==false) then
			for k,v in pairs(this:GetObjVar("MobilesInRegion")) do
				GameObj(v):SendMessage("end_region_buff_effect")
			end
		else
			RefreshView("RegionView")
		end
		UpdateToolTip()
	end
	if(button=="SystemMessageButton") then
		local messageTypeInfo = this:GetObjVar("MessageTypeInfo")
		if(params == "OnEnter") then
			if(messageTypeInfo.OnEnter.System=="pressed") then
				messageTypeInfo.OnEnter.System=""
			else
				messageTypeInfo.OnEnter.System="pressed"
			end
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
		else
			if(messageTypeInfo.OnExit.System=="pressed") then
				messageTypeInfo.OnExit.System=""
			else
				messageTypeInfo.OnExit.System="pressed"
			end
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))			
		end			
	end
	if(button=="InfoButton") then
		local messageTypeInfo = this:GetObjVar("MessageTypeInfo")
		if(params == "OnEnter") then
			if(messageTypeInfo.OnEnter.Info=="pressed") then
				messageTypeInfo.OnEnter.Info=""
			else
				messageTypeInfo.OnEnter.Info="pressed"
			end
			messageTypeInfo.OnEnter.Event = ""
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
		else
			if(messageTypeInfo.OnExit.Info=="pressed") then
				messageTypeInfo.OnExit.Info=""
			else
				messageTypeInfo.OnExit.Info="pressed"
			end
			messageTypeInfo.OnExit.Event = ""
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))			
		end			
	end
	if(button=="EventButton") then
		local messageTypeInfo = this:GetObjVar("MessageTypeInfo")
		if(params == "OnEnter") then
			if(messageTypeInfo.OnEnter.Event=="pressed") then
				messageTypeInfo.OnEnter.Event=""
			else
				messageTypeInfo.OnEnter.Event="pressed"
			end
			messageTypeInfo.OnEnter.Info = ""
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
		else
			if(messageTypeInfo.OnExit.Event=="pressed") then
				messageTypeInfo.OnExit.Event=""
			else
				messageTypeInfo.OnExit.Event="pressed"
			end
			messageTypeInfo.OnExit.Info = ""
			this:SetObjVar("MessageTypeInfo",messageTypeInfo)
			DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))			
		end			
	end
	if(button=="saveButton") then
		this:SetObjVar("OnEnter_Message",fieldData.region_on_enter_message_value)
		this:SetObjVar("OnExit_Message",fieldData.region_on_exit_message_value)
		this:SetName("[CCCC44]"..fieldData.region_name_value)		
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
		user:SystemMessage("Region Information Saved")			
	end
	if(button=="addToMobileListEnter") then
		local list = this:GetObjVar("OnEnter_AddModToMobile")
		table.insert(list,fieldData.mobile_on_add_module)
		this:SetObjVar("OnEnter_AddModToMobile",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="deleteMobileListEnter") then
		local list = this:GetObjVar("OnEnter_AddModToMobile")
		table.remove(list,tonumber(params))
		this:SetObjVar("OnEnter_AddModToMobile",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="addToMobileListExit") then
		local list = this:GetObjVar("OnExit_AddModToMobile")
		table.insert(list,fieldData.mobile_on_remove_module)
		this:SetObjVar("OnExit_AddModToMobile",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="deleteMobileListExit") then
		local list = this:GetObjVar("OnExit_AddModToMobile")
		table.remove(list,tonumber(params))
		this:SetObjVar("OnExit_AddModToMobile",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end	

	if(button=="addToPlayerListEnter") then
		local list = this:GetObjVar("OnEnter_AddModToPlayer")
		table.insert(list,fieldData.player_on_add_module)
		this:SetObjVar("OnEnter_AddModToPlayer",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="deletePlayerListEnter") then
		local list = this:GetObjVar("OnEnter_AddModToPlayer")
		table.remove(list,tonumber(params))
		this:SetObjVar("OnEnter_AddModToPlayer",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="addToPlayerListExit") then
		local list = this:GetObjVar("OnExit_AddModToPlayer")
		table.insert(list,fieldData.player_on_remove_module)
		this:SetObjVar("OnExit_AddModToPlayer",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
	if(button=="deletePlayerListExit") then
		local list = this:GetObjVar("OnExit_AddModToPlayer")
		table.remove(list,tonumber(params))
		this:SetObjVar("OnExit_AddModToPlayer",list)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end	
	if(button=="CreateIt") then
		SaveIt(user)
		DisplayMainWindow(user,this,this:GetObjVar("MessageTypeInfo"))
	end
end)


