-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
------------------------------------------------------------------
-- @function CleanColorFromName(inputStr)
-- borrowed function from citadel
-- @param inputStr - the string to clean the colors from.
------------------------------------------------------------------
function CleanColorFromName(inputStr)
  local color = string.match(inputStr,"%[......%]")
  local outStr = string.gsub(inputStr,"%[......%]","")
  local outStr = string.gsub(outStr,"%[%-%]","")
  return outStr, color
end
------------------------------------------------------------------
-- @function DisplayMainWindow(user,custom_region,message_type_args)
-- @param user - the staff member who is opening the window
-- @param custom_region - the region controller your changing
-- @param message_type_ars - used for passing the systemmessage pressed
--                           for the Event messaging choices.
------------------------------------------------------------------
function DisplayMainWindow(user,custom_region,message_type_args)

	local regionWindow = DynamicWindow("RegionWindow",mapName,360,360,-180,-180,"Default","Center")
	--background
	regionWindow:AddImage(-10,-24,"SectionBackground",370,355,"Sliced","CC5511")
	--top background trim
	regionWindow:AddImage(-8,-22,"SectionDividerFrames_nobackground",356,26,"Sliced","CC5511")
	--header box
	regionWindow:AddImage(94,-45,"SectionBackground",164,34,"Sliced","CC5511")
	--header box background trim top
	regionWindow:AddImage(96,-43,"SectionDividerFrames_nobackground",152,21,"Sliced","CC5511")	
	--header text
	regionWindow:AddLabel(123,-40,"[CC5511]Region Controller",130,21,16,"Left")
	--active/notactive display
	if(custom_region:GetObjVar("Active")== true) then
		regionWindow:AddImage(95,-21,"blank",153,22,"Sliced","004400")
		regionWindow:AddImage(95,-21,"SectionDividerFrames_nobackground",153,20,"Sliced","007700")
		regionWindow:AddLabel(153,-18,"[009900][b]Active[/b]",130,21,16,"Left")
	else
		regionWindow:AddImage(95,-21,"blank",153,22,"Sliced","440000")
		regionWindow:AddImage(95,-21,"SectionDividerFrames_nobackground",153,20,"Sliced","770000")
		regionWindow:AddLabel(150,-18,"[990000][b][i]Offline[/i][/b]",130,21,16,"Left")
	end
	--Toggle Power On and Off

	--edit name
	regionWindow:AddLabel(44,30,"[CC5511]Region Name ",130,21,18,"Left")
	regionWindow:AddTextField(130,27,215,18,"region_name_value",string.sub(this:GetName(),9))
	--edit on enter message
	regionWindow:AddImage(-5,52,"SectionDividerFrames_nobackground",350,20,"Sliced","CC5511")
	regionWindow:AddLabel(5,55,"[CC5511]On Enter Message",130,21,18,"Left")
	regionWindow:AddTextField(-5,72,350,80,"region_on_enter_message_value",custom_region:GetObjVar("OnEnter_Message"))
	regionWindow:AddImage(-5,150,"SectionDividerFrames_nobackground",350,20,"Sliced","CC5511")
	regionWindow:AddButton(90,150,"SystemMessageButton:OnEnter","[BBBBBB]System Message",40,10,"","",false,"Selection",message_type_args.OnEnter.System)
	regionWindow:AddButton(217,150,"InfoButton:OnEnter","[BBBBBB]Info",40,10,"","",false,"Selection",message_type_args.OnEnter.Info)
	regionWindow:AddButton(269,150,"EventButton:OnEnter","[BBBBBB]Event",40,10,"","",false,"Selection",message_type_args.OnEnter.Event)
	regionWindow:AddLabel(5,154,"[FFFF55]Message Type",130,21,18,"Left")
	--edit on exit message
	local y = 125
	regionWindow:AddImage(-5,52+y,"SectionDividerFrames_nobackground",350,20,"Sliced","CC5511")
	regionWindow:AddLabel(5,55+y,"[CC5511]On Exit Message",130,21,18,"Left")
	regionWindow:AddTextField(-5,72+y,350,80,"region_on_exit_message_value",custom_region:GetObjVar("OnExit_Message"))
	regionWindow:AddImage(-5,150+y,"SectionDividerFrames_nobackground",350,20,"Sliced","CC5511")
	regionWindow:AddButton(90, 150+y,"SystemMessageButton:OnExit","[BBBBBB]System Message", 40,  10,"","",false,"Selection",message_type_args.OnExit.System)
	regionWindow:AddButton(217,150+y,"InfoButton:OnExit","[BBBBBB]Info",40,10,"","",false,"Selection",message_type_args.OnExit.Info)
	regionWindow:AddButton(269,150+y,"EventButton:OnExit","[BBBBBB]Event",40,10,"","",false,"Selection",message_type_args.OnExit.Event)
	regionWindow:AddLabel(5,154+y,"[FFFF55]Message Type",130,21,18,"Left")
	--Open up the window

	--Create It Button!!! 
	regionWindow:AddImage(5,301,"Blank",90,22,"Sliced","906030")
	regionWindow:AddImage(7,303,"Blank",86,18,"Sliced","603000")
	regionWindow:AddButton(2,299,"CreateIt:na","",80,24,"[FF7700]Export To XML\n[CCCC44]this will save the region to a xml file for reloading into the game elsewhere.",nil,false,"Invisible")
	regionWindow:AddLabel(14,305,"[BBBB44]Create XML",80,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	


	--save middle section button
	regionWindow:AddImage(295,301,"Blank",50,22,"Sliced","906030")
	regionWindow:AddImage(297,303,"Blank",46,18,"Sliced","603000")
	regionWindow:AddButton(294,299,"saveButton:na","CCCC44".."Buy",50,24,"[FF7700]Save Configuration\n[CCCC44]this will save the current configuration of the region controller",nil,false,"Invisible")
	regionWindow:AddLabel(306,304,"[BBBB44]Save",50,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	
	
	--LEFT PANE
	--background
	regionWindow:AddImage(-210,-24,"SectionBackground",210,355,"Sliced","CC5511")
	--top background trim
	regionWindow:AddImage(-209,-24,"SectionDividerFrames_nobackground",196,355,"Sliced","CC5511")
	--title mobiles
	regionWindow:AddLabel(-181,-14,"[FFFF55]Mobile Modules",180,26,26,"Center")

	--ON ENTER MODULES
	--scroll window code for on enter scripts
	regionWindow:AddLabel(-201,13,"[FFFFFF]On Enter Modules",150,18,18,"Left")
	regionWindow:AddTextField(-201, 31, 140, 20, "mobile_on_add_module", "")
	--add button
	regionWindow:AddImage(-59,30,"Blank",40,22,"Sliced","906030")
	regionWindow:AddImage(-57,32,"Blank",36,18,"Sliced","603000")
	regionWindow:AddButton(-58,34,"addToMobileListEnter:na","CCCC44".."Buy",40,24,"[FF7700]Mobile Module Addition\n[CCCC44]have this script fire when a mobile enters the region area.",nil,false,"Invisible")
	regionWindow:AddLabel(-52,34,"[BBBB44]Add",40,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	
	local swLeftMobileOnEnter = ScrollWindow(-205,55,180,100,20)
	for k,v in pairs(custom_region:GetObjVar("OnEnter_AddModToMobile")) do
		local scrollElement = ScrollElement()
		scrollElement:AddImage(5,0,"Blank",160,20,"Sliced","352515")
		scrollElement:AddImage(5,0,"SectionDividerFrames_nobackground",160,20,"Sliced","CC5511")
		scrollElement:AddLabel(15,5,"[CCCC44]"..v,135,14,14,"Left")
		scrollElement:AddLabel(145,5,"[FF0000][X]",10,14,14,"Left")
		scrollElement:AddButton(145,5,"deleteMobileListEnter:"..k,"",10,14,"[FF7700]Delete This Module?\n[CCCC44]clicking this will delete the module "..v..".",nil,false,"Invisible")
		swLeftMobileOnEnter:Add(scrollElement)
	end
	regionWindow:AddScrollWindow(swLeftMobileOnEnter)

	--ON EXIT MODULES
	--scroll window code for on enter scripts
	regionWindow:AddLabel(-201,173,"[FFFFFF]On Exit Modules",150,18,18,"Left")
	regionWindow:AddTextField(-201, 191, 140, 20, "mobile_on_remove_module", "")
	--add button
	regionWindow:AddImage(-59,190,"Blank",40,22,"Sliced","906030")
	regionWindow:AddImage(-57,192,"Blank",36,18,"Sliced","603000")
	regionWindow:AddButton(-58,194,"addToMobileListExit:na","CCCC44".."Buy",40,24,"[FF7700]Mobile Module Subtraction\n[CCCC44]have this script fire when a mobile exits the region area.",nil,false,"Invisible")
	regionWindow:AddLabel(-52,194,"[BBBB44]Add",40,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	
	local swLeftMobileOnEnter = ScrollWindow(-205,215,180,100,20)
	local scrollElement = ScrollElement()
	for k,v in pairs(custom_region:GetObjVar("OnExit_AddModToMobile")) do
		local scrollElement = ScrollElement()
		scrollElement:AddImage(5,0,"Blank",160,20,"Sliced","352515")
		scrollElement:AddImage(5,0,"SectionDividerFrames_nobackground",160,20,"Sliced","CC5511")
		scrollElement:AddLabel(15,5,"[CCCC44]"..v,150,14,14,"Left")
		scrollElement:AddLabel(145,5,"[FF0000][X]",10,14,14,"Left")
		scrollElement:AddButton(145,5,"deleteMobileListExit:"..k,"",10,14,"[FF7700]Delete This Module?\n[CCCC44]clicking this will delete the module "..v..".",nil,false,"Invisible")
		swLeftMobileOnEnter:Add(scrollElement)
	end
	regionWindow:AddScrollWindow(swLeftMobileOnEnter)

	--RIGHT PANE
	--background
	regionWindow:AddImage(350,-24,"SectionBackground",210,355,"Sliced","CC5511")
	--top background trim
	regionWindow:AddImage(351,-24,"SectionDividerFrames_nobackground",199,355,"Sliced","CC5511")
	--title mobiles
	regionWindow:AddLabel(381,-14,"[FFFF55]Player Modules",180,26,26,"Center")

	--ON ENTER MODULES
	--scroll window code for on enter scripts
	regionWindow:AddLabel(360,13,"[FFFFFF]On Enter Modules",150,18,18,"Left")
	regionWindow:AddTextField(360, 31, 140, 20, "player_on_add_module", "")
	--add button
	regionWindow:AddImage(500,30,"Blank",40,22,"Sliced","906030")
	regionWindow:AddImage(502,32,"Blank",36,18,"Sliced","603000")
	regionWindow:AddButton(502,34,"addToPlayerListEnter:na","CCCC44".."Buy",40,24,"[FF7700]Mobile Module Addition\n[CCCC44]have this script fire when a mobile exits the region area.",nil,false,"Invisible")
	regionWindow:AddLabel(508,34,"[BBBB44]Add",40,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	
	local swPlayerOnEnter = ScrollWindow(355,55,180,100,20)
	for k,v in pairs(custom_region:GetObjVar("OnEnter_AddModToPlayer")) do
		local scrollElement = ScrollElement()
		scrollElement:AddImage(5,0,"Blank",160,20,"Sliced","352515")
		scrollElement:AddImage(5,0,"SectionDividerFrames_nobackground",160,20,"Sliced","CC5511")
		scrollElement:AddLabel(15,5,"[CCCC44]"..v,135,14,14,"Left")
		scrollElement:AddLabel(145,5,"[FF0000][X]",10,14,14,"Left")
		scrollElement:AddButton(145,5,"deletePlayerListEnter:"..k,"",10,14,"[FF7700]Delete This Module?\n[CCCC44]clicking this will delete the module "..v..".",nil,false,"Invisible")
		swPlayerOnEnter:Add(scrollElement)
	end
	regionWindow:AddScrollWindow(swPlayerOnEnter)

	--ON EXIT MODULES
	--scroll window code for on enter scripts
	regionWindow:AddLabel(360,173,"[FFFFFF]On Exit Modules",150,18,18,"Left")
	regionWindow:AddTextField(360, 191, 140, 20, "player_on_remove_module", "")
	--add button
	regionWindow:AddImage(500,190,"Blank",40,22,"Sliced","906030")
	regionWindow:AddImage(502,192,"Blank",36,18,"Sliced","603000")
	regionWindow:AddButton(502,194,"addToPlayerListExit:na","CCCC44".."Buy",40,24,"[FF7700]Mobile Module Addition\n[CCCC44]have this script fire when a mobile exits the region area.",nil,false,"Invisible")
	regionWindow:AddLabel(508,194,"[BBBB44]Add",40,18,18,"",false,false,"PermianSlabSerif_16_Dynamic")	

	local swPlayerOnExit = ScrollWindow(355,215,180,100,20)
	local scrollElement = ScrollElement()
	for k,v in pairs(custom_region:GetObjVar("OnExit_AddModToPlayer")) do
		local scrollElement = ScrollElement()
		scrollElement:AddImage(5,0,"Blank",160,20,"Sliced","352515")
		scrollElement:AddImage(5,0,"SectionDividerFrames_nobackground",160,20,"Sliced","CC5511")
		scrollElement:AddLabel(15,5,"[CCCC44]"..v,150,14,14,"Left")
		scrollElement:AddLabel(145,5,"[FF0000][X]",10,14,14,"Left")
		scrollElement:AddButton(145,5,"deletePlayerListExit:"..k,"",10,14,"[FF7700]Delete This Module?\n[CCCC44]clicking this will delete the module "..v..".",nil,false,"Invisible")
		swPlayerOnExit:Add(scrollElement)
	end
	regionWindow:AddScrollWindow(swPlayerOnExit)

	--display power button over the leftwindow if its open.
	if(custom_region:GetObjVar("Active") == true) then
		regionWindow:AddImage(-14,-70,"SkillIconsFrame",102,102,"Sliced","cc7a00")
		regionWindow:AddImage(7,-51,"Skill_Inscription",66,66,"Sliced","009900")

		regionWindow:AddButton(11,-65,"TogglePower:na","",90,90,"[CC5511]Turn Region Off\n[BBBB33]Clicking this will turn the region controller off.","",false,"Invisible")
	else
		regionWindow:AddImage(-14,-70,"SkillIconsFrame",102,102,"Sliced","cc7a00")
		regionWindow:AddImage(7,-51,"Skill_Inscription",66,66,"Sliced","990000")
		regionWindow:AddButton(11,-65,"TogglePower:na","",90,90,"[CC5511]Turn Region On\n[BBBB33]Clicking this will turn the region controller on.","",false,"Invisible")	
	end	

	user:OpenDynamicWindow(regionWindow,custom_region)
end