-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
function ShowFactionWindow(viewer,viewed,dataTable)
	if(dataTable == nil) then dataTable = {} end
	--if the viewer does not have the module, give it to them
	--if not(viewer:HasModule("systems_factions_window_handler")) then
	--	viewer:AddModule("systems_factions_window_handler",{Viewer=viewer, Viewed=viewed,})
	--else
	--for some odd reason the systems_factions_window_handler did
	--not remove the module so lets clean it up and set it to the
	--new updated version
		if(viewer:HasModule("systems_factions_window_handler")) then
			viewer:DelModule("systems_factions_window_handler")
		end
		viewer:AddModule("systems_factions_window_handler",{Viewer=viewer, Viewed=viewed,})
	--end
	--create the core window
	local factionWindow = DynamicWindow("FactionWindow","",0,0,0,0,"Default")
	--create the scroll window
	local scrollWindow = ScrollWindow(-10,5,190,400,40)
	--create the generic element variable for the scrollWindow variable
	local scrollElement = ScrollElement()
	--background
	factionWindow:AddImage(-17,-28,"Blank",210,440,"Sliced","251010")
	--background border
	factionWindow:AddImage(-17,-28,"SectionDividerFrames_nobackground",210,440,"Sliced","FF7700")
	--nameplate
	factionWindow:AddImage(15, -35,"SkillsCategoryTitleFrame",150,35,"Sliced","502020")
	--nameplate border
	factionWindow:AddImage(15,-35,"SectionDividerFrames_nobackground",150,35,"Sliced","FF7700")
	--nameplate text
	factionWindow:AddLabel(50,-28,"[EECC33]Factions",140,28,28,"Center",false,false,"PermianSlabSerif_16_Dynamic")
	--loop through Systems_Factions table and display the faction data
	for k,v in pairs(viewed:GetObjVar("Systems_Factions")) do
		local scrollElement = ScrollElement()
		--element top background
		scrollElement:AddImage(1,1,"Blank",175,40,"Sliced","301515")
		--element bottom background
		scrollElement:AddImage(1,22,"Blank",175,20,"Sliced","200808")
		--element border
		scrollElement:AddImage(1,1,"SectionDividerFrames_nobackground",175,40,"Sliced","FF7700")
		--faction name label
		scrollElement:AddLabel(10,7,"[AAAA00]"..v[1],100,18,18,"Left",false,false,"")
		--faction score label
		scrollElement:AddButton(150,23,"na|na","",50,18,"[FF7700]Faction Score[EEEE00]\n[i]This is your current faction score with [FF7700]"..v[1].."[EEEE00]. Doing quests or other actions may improve this score.[/i]",nil,false,"Invisible")
		scrollElement:AddLabel(130,23,"[FFAA44]"..v[2],50,18,18,"Center",false,false,"")
		--if we are a admin, then let us adjust the factions on the target
		if(IsGod(viewer)) then
			--delete button background
			scrollElement:AddImage(150,4,"TitleBackground",20,15,"Sliced","BB2200")
			--delete button text
			scrollElement:AddLabel(157,6,"[BB2200]X",15,15,12,"Left",false,false,"")
			--delete button invisible overlay
			scrollElement:AddButton(150,4,"RemoveFaction|"..v[1].."|"..viewer.Id.."|"..viewed.Id,"Cancel",20,15,"[FF7700]Remove Faction[EEEE00]\n[i]Clicking this will remove the [FF7700]"..v[1].."[EEEE00] faction from the players faction table.[/i]",nil,false,"Invisible")
			--edit button background
			scrollElement:AddImage(130,4,"TitleBackground",20,15,"Sliced","00BB22")
			--edit button text
			scrollElement:AddLabel(137,6,"[00BB22]E",15,15,12,"Left",false,false,"")
			--edit button invisible overlay
			scrollElement:AddButton(130,4,"EditFaction|"..v[1].."|"..viewer.Id.."|"..viewed.Id,"Okay",20,15,"[FF7700]Edit Faction[EEEE00]\n[i]Clicking this will allow you to edit the [FF7700]"..v[1].."[EEEE00] faction in the players faction table.[/i]",nil,false,"Invisible")
		end
		--add the new element to the scroll window
		scrollWindow:Add(scrollElement)
	end	
	--add the scrollwindow to our dynamic window
	factionWindow:AddScrollWindow(scrollWindow)
	--open the dynamic window and allow the viewer to
	--recieve the event handler messages
	if(dataTable ~= nil) then
		if(dataTable.Type == "RemoveFaction") then
			--background image
			factionWindow:AddImage(230,4,"Blank",200,50,"Sliced","251010")
			--background border
			factionWindow:AddImage(230,4,"SectionDividerFrames_nobackground",200,50,"Sliced","FF7700")
			--okay button background
			factionWindow:AddImage(235,34,"TitleBackground",50,15,"Sliced","00BB22")
			--okay button text
			factionWindow:AddLabel(245,36,"[00BB22]Okay",50,15,12,"Left",false,false,"")
			--okay button invisible overlay
			factionWindow:AddButton(235,34,"Okay|"..dataTable.Faction.."|"..viewer.Id.."|"..viewed.Id,"",50,15,"[FF7700]Remove Faction[EEEE00]\n[i]Clicking this will remove the [FF7700]"..dataTable.Faction.."[EEEE00] faction from the players faction table.[/i]",nil,false,"Invisible")
			--cancel button background
			factionWindow:AddImage(375,34,"TitleBackground",50,15,"Sliced","BB2200")
			--cancel button text
			factionWindow:AddLabel(385,36,"[BB2200]Cancel",50,15,12,"Left",false,false,"")
			--cancel button invisible overlay
			factionWindow:AddButton(375,34,"Cancel|"..dataTable.Faction.."|"..viewer.Id.."|"..viewed.Id,"",50,15,"[FF7700]Edit Faction[EEEE00]\n[i]Clicking this will cancel removing the [FF7700]"..dataTable.Faction.."[EEEE00] faction.[/i]",nil,false,"Invisible")
			--confirmation message
			factionWindow:AddLabel(237,10,"[EEEE00]Remove [FFFF00]" .. dataTable.Faction.."[EEEE00] faction?",190,14,14,"Left",false,false,"")
		end
	end
	if(dataTable ~= nil) then
		if(dataTable.Type == "EditFaction") then
			--background image
			factionWindow:AddImage(230,4,"Blank",200,75,"Sliced","251010")
			--background border
			factionWindow:AddImage(230,4,"SectionDividerFrames_nobackground",200,75,"Sliced","FF7700")
			--okay button background
			factionWindow:AddImage(235,54,"TitleBackground",50,15,"Sliced","00BB22")
			--okay button text
			factionWindow:AddLabel(245,56,"[00BB22]Okay",50,15,12,"Left",false,false,"")
			--okay button invisible overlay
			factionWindow:AddButton(235,54,"EditOkay|"..dataTable.Faction.."|"..viewer.Id.."|"..viewed.Id,"",50,15,"[FF7700]Edit Faction[EEEE00]\n[i]Clicking this will edit the [FF7700]"..dataTable.Faction.."[EEEE00] faction from the players faction table.[/i]",nil,false,"Invisible")
			--cancel button background
			factionWindow:AddImage(375,54,"TitleBackground",50,15,"Sliced","BB2200")
			--cancel button text
			factionWindow:AddLabel(385,56,"[BB2200]Cancel",50,15,12,"Left",false,false,"")
			--cancel button invisible overlay
			factionWindow:AddButton(375,54,"EditCancel|"..dataTable.Faction.."|"..viewer.Id.."|"..viewed.Id,"",50,15,"[FF7700]Edit Faction[EEEE00]\n[i]Clicking this will cancel editing the [FF7700]"..dataTable.Faction.."[EEEE00] faction.[/i]",nil,false,"Invisible")
			--confirmation message
			factionWindow:AddLabel(237,10,"[EEEE00]Editing [FFFF00]" .. dataTable.Faction.."[EEEE00] faction",190,14,14,"Left",false,false,"")
			
			local value = 0
			for k,v in pairs(viewed:GetObjVar("Systems_Factions")) do
				if(v[1]==dataTable.Faction) then
					value = v[2]
				end
			end
			--textfield for value
			factionWindow:AddTextField(235, 25, 180, 20, "faction_value", tostring(value))
		end
	end	
	--open the dynamic window for the viewer
	viewer:OpenDynamicWindow(factionWindow,viewer)	
end

--when this object is in your pack double click it to
--launch the window you are testing above
-- RegisterEventHandler(EventType.Message, "UseObject", 
-- function(user,usedType)
-- 	--remember this function may chance as you may
-- 	--want to change the arguments you pass or any
-- 	--other information here.
-- 	user:CloseDynamicWindow("FactionWindow")
--     TestWindow(user,user)
-- end)

