-- written by Gizmo
----------------------------------------------------------------------
-- If you like Project Phoenix and want to help support the project
-- you could send any donation amount to jessebutler1975@gmail.com at
-- paypal.com
--
-- Thank you for using my product, 
-- I hope you enjoy it as much as I do
----------------------------------------------------------------------
require 'default:tool_miningpick'
--================================================================
--                 	   PROJECT PHOENIX OVERRIDE
--================================================================
ResourceHarvester.CollectResource = function(user,resourceType)
	local backpackObj = user:GetEquippedObject("Backpack")  
	if( backpackObj ~= nil ) then
		local resSkill = ResourceData.ResourceInfo[resourceType].HarvestBonusSkill		
		local skillVal = 0
		if(resSkill) then
			skillVal = GetSkillLevel(user,resSkill)
		end
		mHarvestedStackCount = 1
		if( Success(0.25) ) then
			mHarvestedStackCount = 2
		end
		local difficulty = 1
		if ( ResourceData.ResourceInfo[resourceType].Difficulty ) then
			difficulty = SkillValueMinMax( skillVal, ResourceData.ResourceInfo[resourceType].Difficulty.Min or 100, ResourceData.ResourceInfo[resourceType].Difficulty.Max or 100)
		end
		if not CheckSkillChance( user, resSkill, skillVal, difficulty ) then	
	    	user:SystemMessage("Failed to harvest any usable resources.", "info")
			return
		end
		resourceType = GetHarvestResourceType(user,resourceType,resSkill)
		if (resourceType == nil) then return end	
	    --EDIT QUEST SYSTEM 
	    if not( TryAddToStack(resourceType,backpackObj,mHarvestedStackCount) ) then
	        local templateId = ResourceData.ResourceInfo[resourceType].Template
	    	CreateObjInBackpackOrAtLocation(user,templateId, "create_miningpick_harvest", mHarvestedStackCount)
			CustomQuests.Helpers.CheckQuestObjectives(user, templateId)		    
	    else
	    	local templateId = ResourceData.ResourceInfo[resourceType].Template
	    	CustomQuests.Helpers.CheckQuestObjectives(user, templateId)
	    end
	    --END EDIT QUEST SYSTEM
	    local displayName = GetResourceDisplayName(resourceType)
	    user:SystemMessage("Harvested "..mHarvestedStackCount.." "..displayName..".", "info")
	    user:NpcSpeech("[F4FA58]+"..mHarvestedStackCount.." "..displayName.."[-]", "combat")    
	end	
end
--================================================================
--                  END PROJECT PHOENIX OVERRIDE
--================================================================


